require "import"
import "android.widget.*"
import "android.view.View"
import "android.os.*"
import "android.content.*"
import "android.net.Uri"
import "android.app.AlertDialog"
import "android.graphics.Color"

-- Group List
group_list = {
  {"accessible audio games", "https://chat.whatsapp.com/JL9JS70K5whDmMZ69DcdZI"},
  {"accessible text support", "https://chat.whatsapp.com/CFr3Ul1yfp2F8cFdyvLRe5"},
  {"Advance AI Oriented Training by NVS and NFB", "https://chat.whatsapp.com/JomS5lVxPWP5AoUMfGHBWg"},
  {"All Blinds of the World", "https://chat.whatsapp.com/ILtPX9sA9TrD7HpvDwtp8B"},
  {"All divyang news", "https://chat.whatsapp.com/HpcpcnYoDqn92jzKpHi8Au"},
  {"Assignment helps du student only", "https://chat.whatsapp.com/F7CIORhfVYNGRVUjrWXa78"},
  {"Blind Gamers Community", "https://chat.whatsapp.com/JL9JS70K5whDmMZ69DcdZI"},
  {"Divy Drishti", "https://chat.whatsapp.com/Fi9ieTvP1Vn3Dbn04zmA3Y"},
  {"General Group", "https://chat.whatsapp.com/HuUV3Y9tLHi3uhMm4SK7FY"},
  {"Hi genius", "https://chat.whatsapp.com/Bb5nHpmiNUjBUGlCWZJnQs"},
  {"Independen blind group 2", "https://chat.whatsapp.com/BsTjncArXUpDC42Gt9XVZW"},
  {"Information Central Society", "https://chat.whatsapp.com/BqKq0znF4NMDSYXpk8cAmG"},
  {"Kns blind friends", "https://chat.whatsapp.com/Fihfu5piqSP82jW4Csp6xA"},
  {"KNS all India news", "https://chat.whatsapp.com/Cm4YyvWcU4F02cXgW6URe4"},
  {"KTM Official WhatsApp Group", "https://chat.whatsapp.com/KKQmqShxY6KHufRXz6asL6"},
  {"New Updates for V I Discussion Group", "https://chat.whatsapp.com/BSSMkocftGTKmZ9UzjvS2k"},
  {"Perfect Education", "https://chat.whatsapp.com/IcoBCTMavCNFNJKNKvyq0p"},
  {"Table-Ex Comunidad Española", "https://chat.whatsapp.com/JhTP2521v66EqYtWzX38sB"},
  {"Technology World for V I", "https://chat.whatsapp.com/IOmT9PvizP14cmOByWnW7q"},
  {"WhatsApp World", "https://chat.whatsapp.com/GAif6bUQp4OKR1AOQdtrrrU"},
  {"ऑल इंडिया हैंडीकैप दोस्त", "https://chat.whatsapp.com/DjaXmuVQ7wM9Kpap01NHRH"},
  {"🇮🇳 दिव्यांग संघ 2024.2025 🇮🇳", "https://chat.whatsapp.com/E3UmEpl5dC09wCD5bXC9Ix"},
  {"नवयुग एकता मंच", "https://chat.whatsapp.com/FWIqynNReFTIEk2fuG1PzJ"},
  -- Telegram last
  {"Android Knowledge for Blind Telegram Group", "https://t.me/tech_hup"},
  {"Join Our Telegram Channel", "https://t.me/+ibCyQTEm8KgzOTA1"}
}

-- Sort groups (Telegram last)
table.sort(group_list, function(a, b)
  local aTelegram = a[2]:find("t.me")
  local bTelegram = b[2]:find("t.me")
  if aTelegram and not bTelegram then return false end
  if not aTelegram and bTelegram then return true end
  return a[1]:lower() < b[1]:lower()
end)

-- Layout Design
layout = {
  LinearLayout,
  id = "mainLayout",
  orientation = "vertical",
  padding = "10dp",
  {
    TextView,
    id = "welcomeText",
    text = "welcome to vi community",
    textSize = "20sp",
    textColor = Color.GREEN,
    gravity = "center",
    layout_width = "match_parent"
  },
  {
    TextView,
    id = "devText",
    text = "developed by hersh nagvanshi",
    textSize = "16sp",
    textColor = Color.BLUE,
    gravity = "center",
    layout_width = "match_parent"
  },
  {
    Button,
    id = "themeToggle",
    text = "Switch to Dark Mode",
    layout_width = "match_parent"
  },
  {
    TextView,
    id = "timeText",
    text = "",
    textSize = "16sp",
    textColor = Color.BLACK,
    gravity = "center",
    layout_width = "match_parent"
  },
  {
    ListView,
    id = "list",
    layout_weight = 1
  },
  {
    Button,
    id = "exitButton",
    text = "Exit",
    layout_width = "match_parent"
  }
}

activity.setContentView(loadlayout(layout))

-- टाइम अपडेट करें
local handler = Handler()
function updateTime()
  local t = os.date("%c")
  timeText.setText("time: " .. t)
  handler.postDelayed(updateTime, 1000)
end
updateTime()

-- लिस्ट में नंबरिंग
names = {}
for i, v in ipairs(group_list) do
  names[i] = tostring(i) .. ". " .. v[1]
end

-- Adapter सेट करें
adapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, String(names))
list.setAdapter(adapter)

-- लिंक पर क्लिक
list.setOnItemClickListener(AdapterView.OnItemClickListener{
  onItemClick = function(parent, view, position, id)
    local url = group_list[position + 1][2]
    local intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
    activity.startActivity(intent)
  end
})

-- contentDescription
list.setOnItemSelectedListener(AdapterView.OnItemSelectedListener{
  onItemSelected = function(parent, view, position, id)
    if view then view.setContentDescription(names[position + 1]) end
  end,
  onNothingSelected = function() end
})

-- Exit डायलॉग
exitButton.onClick = function()
  AlertDialog.Builder(activity)
    .setTitle("Exit Confirmation")
    .setMessage("Are you sure exit?")
    .setPositiveButton("OK", {onClick=function() activity.finish() end})
    .setNegativeButton("Cancel", nil)
    .show()
end

-- 🌗 Theme Toggle
isDark = false
themeToggle.onClick = function()
  if isDark then
    -- Light Mode
    mainLayout.setBackgroundColor(0xFFFFFFFF)
    welcomeText.setTextColor(0xFF00FF00)
    devText.setTextColor(0xFF0000FF)
    timeText.setTextColor(0xFF000000)
    themeToggle.setText("Switch to Dark Mode")
    isDark = false
  else
    -- Dark Mode
    mainLayout.setBackgroundColor(0xFF000000)
    welcomeText.setTextColor(0xFFFFFF00)
    devText.setTextColor(0xFFFF00FF)
    timeText.setTextColor(0xFFFFFFFF)
    themeToggle.setText("Switch to Light Mode")
    isDark = true
  end
end